Index: npl/mailserver/netqmail/roberto-netqmail-1.06.patch-latest
===================================================================
--- npl/mailserver/netqmail/roberto-netqmail-1.06.patch-latest	(revision cd8630be6536b27ae1c762184795ee87723202ab)
+++ npl/mailserver/netqmail/roberto-netqmail-1.06.patch-latest	(revision 1ebb340be23e45ead361b729734f0e82007af6bd)
@@ -1404,5 +1074,5 @@
 diff -ruN ../netqmail-1.06-original/Makefile netqmail-1.06/Makefile
 --- ../netqmail-1.06-original/Makefile	2007-11-30 21:22:54.000000000 +0100
-+++ netqmail-1.06/Makefile	2018-04-03 15:05:13.390470191 +0200
++++ netqmail-1.06/Makefile	2019-06-26 16:48:00.745225709 +0200
 @@ -1,5 +1,14 @@
  # Don't edit Makefile! Use conf-* for configuration.
@@ -1648,23 +1318,34 @@
  
  fs.a: \
-@@ -703,7 +754,7 @@
+@@ -702,8 +753,15 @@
+ 	./compile hfield.c
  
  hier.o: \
- compile hier.c auto_qmail.h auto_split.h auto_uids.h fmt.h fifo.h
+-compile hier.c auto_qmail.h auto_split.h auto_uids.h fmt.h fifo.h
 -	./compile hier.c
++compile hier.c auto_qmail.h auto_split.h auto_uids.h fmt.h fifo.h channels.h
 +	./compile $(DEFINES) hier.c
++
++channels.h: \
++conf-channels channels.g
++	cat channels.g \
++	| sed s}NUMCHANNELS}"`head -1 conf-channels`"}g \
++	> channels.h
++	chmod 644 channels.h
  
  home: \
  home.sh conf-qmail
-@@ -755,7 +806,7 @@
+@@ -754,8 +812,8 @@
+ 
  install-big.o: \
  compile install-big.c auto_qmail.h auto_split.h auto_uids.h fmt.h \
- fifo.h
+-fifo.h
 -	./compile install-big.c
++fifo.h channels.h
 +	./compile $(DEFINES) install-big.c
  
  install.o: \
  compile install.c substdio.h strerr.h error.h open.h readwrite.h \
-@@ -777,38 +828,52 @@
+@@ -777,38 +835,52 @@
  	./compile ip.c
  
@@ -1729,5 +1410,5 @@
  load: \
  make-load warn-auto.sh systype
-@@ -890,6 +955,38 @@
+@@ -890,6 +962,38 @@
  readwrite.h open.h headerbody.h maildir.h strerr.h
  	./compile maildirwatch.c
@@ -1768,5 +1449,5 @@
  warn-auto.sh mailsubj.sh conf-qmail conf-break conf-split
  	cat warn-auto.sh mailsubj.sh \
-@@ -934,8 +1031,9 @@
+@@ -934,8 +1038,9 @@
  preline.0 condredirect.0 bouncesaying.0 except.0 maildirmake.0 \
  maildir2mbox.0 maildirwatch.0 qmail.0 qmail-limits.0 qmail-log.0 \
@@ -1780,5 +1461,5 @@
  mbox.0: \
  mbox.5
-@@ -1107,11 +1205,80 @@
+@@ -1107,11 +1212,80 @@
  	| sed s}SPAWN}"`head -1 conf-spawn`"}g \
  	> qmail-control.5
@@ -1862,5 +1543,5 @@
  qmail-getpw.0: \
  qmail-getpw.8
-@@ -1125,6 +1292,28 @@
+@@ -1125,6 +1299,28 @@
  	| sed s}SPAWN}"`head -1 conf-spawn`"}g \
  	> qmail-getpw.8
@@ -1891,5 +1572,5 @@
  compile qmail-getpw.c readwrite.h substdio.h subfd.h substdio.h \
  error.h exit.h byte.h str.h case.h fmt.h auto_usera.h auto_break.h \
-@@ -1136,15 +1325,16 @@
+@@ -1136,15 +1332,16 @@
  	nroff -man qmail-header.5 > qmail-header.0
  
@@ -1911,5 +1592,5 @@
  qmail-inject.0: \
  qmail-inject.8
-@@ -1171,15 +1361,20 @@
+@@ -1171,15 +1368,20 @@
  	> qmail-limits.7
  
@@ -1936,5 +1617,5 @@
  qmail-local.0: \
  qmail-local.8
-@@ -1200,11 +1395,11 @@
+@@ -1200,11 +1402,11 @@
  qmail-lspawn: \
  load qmail-lspawn.o spawn.o prot.o slurpclose.o coe.o sig.a wait.a \
@@ -1950,5 +1631,5 @@
  qmail-lspawn.0: \
  qmail-lspawn.8
-@@ -1213,9 +1408,22 @@
+@@ -1213,9 +1415,22 @@
  qmail-lspawn.o: \
  compile qmail-lspawn.c fd.h wait.h prot.h substdio.h stralloc.h \
@@ -1974,5 +1655,5 @@
  load qmail-newmrh.o cdbmss.o getln.a open.a cdbmake.a seek.a case.a \
  stralloc.a alloc.a strerr.a substdio.a error.a str.a auto_qmail.o
-@@ -1269,11 +1477,13 @@
+@@ -1269,11 +1484,13 @@
  qmail-pop3d: \
  load qmail-pop3d.o commands.o case.a timeoutread.o timeoutwrite.o \
@@ -1990,5 +1671,5 @@
  qmail-pop3d.0: \
  qmail-pop3d.8
-@@ -1419,13 +1629,13 @@
+@@ -1419,13 +1636,13 @@
  	nroff -man qmail-qstat.8 > qmail-qstat.0
  
@@ -2010,5 +1691,5 @@
  qmail-queue.0: \
  qmail-queue.8
-@@ -1439,14 +1649,18 @@
+@@ -1439,14 +1656,18 @@
  
  qmail-remote: \
@@ -2033,5 +1714,5 @@
  qmail-remote.0: \
  qmail-remote.8
-@@ -1455,7 +1669,7 @@
+@@ -1455,7 +1676,7 @@
  qmail-remote.o: \
  compile qmail-remote.c sig.h stralloc.h gen_alloc.h substdio.h \
@@ -2042,5 +1723,5 @@
  tcpto.h readwrite.h timeoutconn.h timeoutread.h timeoutwrite.h
  	./compile qmail-remote.c
-@@ -1463,11 +1677,11 @@
+@@ -1463,11 +1684,11 @@
  qmail-rspawn: \
  load qmail-rspawn.o spawn.o tcpto_clean.o now.o coe.o sig.a open.a \
@@ -2056,5 +1737,5 @@
  qmail-rspawn.0: \
  qmail-rspawn.8
-@@ -1475,20 +1689,21 @@
+@@ -1475,31 +1696,33 @@
  
  qmail-rspawn.o: \
@@ -2070,6 +1751,7 @@
  datetime.a case.a ndelay.a getln.a wait.a seek.a fd.a sig.a open.a \
  lock.a stralloc.a alloc.a substdio.a error.a str.a fs.a auto_qmail.o \
- auto_split.o env.a
+-auto_split.o env.a
 -	./load qmail-send qsutil.o control.o constmap.o newfield.o \
++auto_split.o env.a auto_spawn.o
 +	./load qmail-send rcpthosts.o cdb.a srs.o qsutil.o control.o constmap.o newfield.o \
  	prioq.o trigger.o fmtqfn.o quote.o now.o readsubdir.o \
@@ -2077,19 +1759,34 @@
  	wait.a seek.a fd.a sig.a open.a lock.a stralloc.a alloc.a \
 -	substdio.a error.a str.a fs.a auto_qmail.o auto_split.o env.a
-+	substdio.a error.a str.a fs.a auto_qmail.o auto_split.o env.a \
++	substdio.a error.a str.a fs.a auto_qmail.o auto_split.o env.a auto_spawn.o \
 +	-I/usr/local/include -L/usr/local/lib -lsrs2
  
  qmail-send.0: \
  qmail-send.8
-@@ -1509,7 +1724,7 @@
+ 	nroff -man qmail-send.8 > qmail-send.0
+ 
+ qmail-send.8: \
+-qmail-send.9 conf-break conf-spawn
++qmail-send.9 conf-break conf-spawn conf-channels
+ 	cat qmail-send.9 \
+ 	| sed s}QMAILHOME}"`head -1 conf-qmail`"}g \
+ 	| sed s}BREAK}"`head -1 conf-break`"}g \
+ 	| sed s}SPAWN}"`head -1 conf-spawn`"}g \
++	| sed s}CHANNELS}"`head -1 conf-channels`"}g \
+ 	> qmail-send.8
+ 
+ qmail-send.o: \
+@@ -1508,8 +1731,8 @@
+ substdio.h alloc.h error.h stralloc.h gen_alloc.h str.h byte.h fmt.h \
  scan.h case.h auto_qmail.h trigger.h newfield.h stralloc.h quote.h \
  qmail.h substdio.h qsutil.h prioq.h datetime.h gen_alloc.h constmap.h \
- fmtqfn.h readsubdir.h direntry.h
+-fmtqfn.h readsubdir.h direntry.h
 -	./compile qmail-send.c
++fmtqfn.h readsubdir.h direntry.h channels.h auto_qmail.h
 +	./compile $(DEFINES) qmail-send.c
  
  qmail-showctl: \
  load qmail-showctl.o auto_uids.o control.o open.a getln.a stralloc.a \
-@@ -1528,21 +1743,26 @@
+@@ -1528,21 +1751,26 @@
  compile qmail-showctl.c substdio.h subfd.h substdio.h exit.h fmt.h \
  str.h control.h constmap.h stralloc.h gen_alloc.h direntry.h \
@@ -2129,5 +1826,5 @@
  qmail-smtpd.0: \
  qmail-smtpd.8
-@@ -1551,9 +1771,10 @@
+@@ -1551,9 +1779,10 @@
  qmail-smtpd.o: \
  compile qmail-smtpd.c sig.h readwrite.h stralloc.h gen_alloc.h \
@@ -2143,14 +1840,16 @@
  
  qmail-start: \
-@@ -1574,7 +1795,7 @@
+@@ -1573,8 +1802,8 @@
+ 	> qmail-start.8
  
  qmail-start.o: \
- compile qmail-start.c fd.h prot.h exit.h fork.h auto_uids.h
+-compile qmail-start.c fd.h prot.h exit.h fork.h auto_uids.h
 -	./compile qmail-start.c
++compile qmail-start.c fd.h prot.h exit.h fork.h auto_uids.h channels.h
 +	./compile $(DEFINES) qmail-start.c
  
  qmail-tcpok: \
  load qmail-tcpok.o open.a lock.a strerr.a substdio.a error.a str.a \
-@@ -1606,6 +1827,20 @@
+@@ -1606,6 +1835,20 @@
  fmt.h ip.h lock.h error.h exit.h datetime.h now.h datetime.h
  	./compile qmail-tcpto.c
@@ -2167,5 +1866,5 @@
 +compile alloc.h auto_qmail.h byte.h constmap.h control.h direntry.h error.h \
 +exit.h fmt.h fmtqfn.h getln.h open.h ndelay.h now.h readsubdir.h readwrite.h \
-+scan.h select.h str.h stralloc.h substdio.h trigger.h
++scan.h select.h str.h stralloc.h substdio.h trigger.h channels.h
 +	./compile $(DEFINES) qmail-todo.c
 +
@@ -2173,5 +1872,5 @@
  warn-auto.sh qmail-upq.sh conf-qmail conf-break conf-split
  	cat warn-auto.sh qmail-upq.sh \
-@@ -1639,10 +1874,10 @@
+@@ -1639,10 +1882,10 @@
  qreceipt: \
  load qreceipt.o headerbody.o hfield.o quote.o token822.o qmail.o \
@@ -2186,5 +1885,5 @@
  qreceipt.0: \
  qreceipt.1
-@@ -1779,7 +2014,7 @@
+@@ -1779,7 +2022,7 @@
  qmail-qread.c qmail-qstat.sh qmail-queue.c qmail-remote.c \
  qmail-rspawn.c qmail-send.c qmail-showctl.c qmail-smtpd.c \
@@ -2195,5 +1894,5 @@
  except.c bouncesaying.c condredirect.c maildirmake.c maildir2mbox.c \
  maildirwatch.c splogger.c qail.sh elq.sh pinq.sh qmail-upq.sh \
-@@ -1813,8 +2048,9 @@
+@@ -1813,8 +2056,9 @@
  trywaitp.c sig.h sig_alarm.c sig_block.c sig_catch.c sig_pause.c \
  sig_pipe.c sig_child.c sig_term.c sig_hup.c sig_misc.c sig_bug.c \
@@ -2207,5 +1906,5 @@
  getln.h getln.c getln2.3 getln2.c sgetopt.3 sgetopt.h sgetopt.c \
  subgetopt.3 subgetopt.h subgetopt.c error.3 error_str.3 error_temp.3 \
-@@ -1824,10 +2060,11 @@
+@@ -1824,10 +2068,11 @@
  headerbody.h headerbody.c token822.h token822.c control.h control.c \
  datetime.3 datetime.h datetime.c datetime_un.c prioq.h prioq.c \
@@ -2221,5 +1920,5 @@
  	chmod 400 shar
  
-@@ -1897,6 +2134,23 @@
+@@ -1897,6 +2142,23 @@
  	./chkspawn
  	./compile spawn.c
@@ -2245,5 +1944,5 @@
  load splogger.o substdio.a error.a str.a fs.a syslog.lib socket.lib
  	./load splogger substdio.a error.a str.a fs.a  `cat \
-@@ -1911,13 +2165,33 @@
+@@ -1911,13 +2173,33 @@
  scan.h fmt.h
  	./compile splogger.c
@@ -2285,5 +1984,5 @@
  str_chr.o: \
  compile str_chr.c str.h
-@@ -1927,6 +2201,10 @@
+@@ -1927,6 +2209,10 @@
  compile str_cpy.c str.h
  	./compile str_cpy.c
@@ -2296,5 +1995,5 @@
  compile str_diff.c str.h
  	./compile str_diff.c
-@@ -2006,6 +2284,11 @@
+@@ -2006,6 +2292,11 @@
  compile strerr_sys.c error.h strerr.h
  	./compile strerr_sys.c
@@ -2308,5 +2007,5 @@
  compile subfderr.c readwrite.h substdio.h subfd.h substdio.h
  	./compile subfderr.c
-@@ -2066,11 +2349,11 @@
+@@ -2066,11 +2357,11 @@
  
  tcp-env: \
@@ -2324,5 +2023,5 @@
  
  tcp-env.0: \
-@@ -2108,6 +2391,19 @@
+@@ -2108,6 +2399,19 @@
  compile timeoutwrite.c timeoutwrite.h select.h error.h readwrite.h
  	./compile timeoutwrite.c
@@ -2344,5 +2043,5 @@
  compile token822.c stralloc.h gen_alloc.h alloc.h str.h token822.h \
  gen_alloc.h gen_allocdefs.h
-@@ -2139,3 +2435,165 @@
+@@ -2139,3 +2443,173 @@
  wait_pid.o: \
  compile wait_pid.c error.h haswaitp.h
@@ -2464,24 +2163,32 @@
 +	> dk-filter
 +
-+DKIMHDRS = dkim.h dkimdns.h dkimbase.h dkimsign.h dkimverify.h
++DKIMHDRS = dkim.h dkimdns.h dkimbase.h dkimsign.h dkimverify.h time_t_size.h
 +DKIMSRCS = dkimfuncs.cpp dkimbase.cpp
 +DKIMOBJS = $(DKIMSRCS:.cpp=.o)
-+dkim : libdkim.a dkim.o dkimdns.o
++dkim: libdkim.a dkim.o dkimdns.o
 +	g++ -o dkim $(LFLAGS) -L. dkim.o dkimdns.o libdkim.a `cat dns.lib` -lcrypto
 +
-+dkimverify.o: dkim.h dkimdns.h dkimverify.h dkimverify.cpp
-+	g++ -DHAVE_CONFIG_H -c dkimverify.cpp
++time_t_size.h: time_t_size.c compile load
++	(./compile time_t_size.c && ./load time_t_size && \
++        	./time_t_size) > time_t_size.h
++	rm -f time_t_size.o time_t_size
++
++dkimfuncs.o: dkimfuncs.cpp time_t_size.h
++	g++ -DHAVE_EVP_SHA256 -c dkimfuncs.cpp
++
++dkimverify.o: dkim.h dkimdns.h dkimverify.h dkimverify.cpp time_t_size.h
++	g++ -DHAVE_EVP_SHA256 -c dkimverify.cpp
 +
 +dkimsign.o: dkim.h dkimsign.h dkimsign.cpp
-+	g++ -DHAVE_CONFIG_H -c dkimsign.cpp
++	g++ -DHAVE_EVP_SHA256 -c dkimsign.cpp
 +
 +dkim.o: dkim.c $(DKIMHDRS)
-+	g++ -DHAVE_CONFIG_H -I. -DHAVE_EVP_SHA256 -c dkim.c
-+
-+libdkim.a: $(DKIMOBJS) dkimverify.o dkimsign.o makelib
++	g++ -DHAVE_EVP_SHA256 -I. -DHAVE_EVP_SHA256 -c dkim.c
++
++libdkim.a: $(DKIMOBJS) dkimverify.o dkimsign.o makelib time_t_size.h
 +	rm -f libdkim.a
 +	./makelib libdkim.a $(DKIMOBJS) dkimsign.o dkimverify.o
 +.cpp.o:
-+	g++ -I. -DHAVE_CONFIG_H $(CFLAGS) $(INCL) -c $<
++	g++ -I. -DHAVE_EVP_SHA256 $(CFLAGS) $(INCL) -c $<
 +
 +cert cert-req: \
@@ -2512,5 +2219,5 @@
 diff -ruN ../netqmail-1.06-original/Makefile-cert.mk netqmail-1.06/Makefile-cert.mk
 --- ../netqmail-1.06-original/Makefile-cert.mk	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/Makefile-cert.mk	2016-11-22 21:03:57.103528399 +0100
++++ netqmail-1.06/Makefile-cert.mk	2019-02-27 20:57:13.379025191 +0100
 @@ -0,0 +1,21 @@
 +cert-req: req.pem
